﻿using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThinkGeo.Core;
using ThinkGeo.UI.Wpf;

namespace WpfApp1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private async void mapView_Loaded(object sender, RoutedEventArgs e)
        {
           // ThinkGeoDebugger.DisplayTileId = true;
            // Set the Map's Unit to Meter.
            Map.MapUnit = GeographyUnit.Meter;
            Map.FocusVisualStyle = null;
            Map.TrackOverlay.TrackMode = TrackMode.Freehand;
            Map.IsManipulationEnabled = true;
            

            // Set the Current Extent to the Max Extent of ThinkGeo Map.
            Map.CurrentExtent = MaxExtents.ThinkGeoMaps;
            // Add a base map overlay.
            var baseOverlay = new ThinkGeoCloudRasterMapsOverlay("AOf22-EmFgIEeK4qkdx5HhwbkBjiRCmIDbIYuP8jWbc~",
            "xK0pbuywjaZx4sqauaga8DMlzZprz0qQSjLTow90EhBx5D8gFd2krw~~", ThinkGeoCloudRasterMapsMapType.Light_V1_X1);

            // Set up the tile cache for the base overlay, passing in the location and an ID to distinguish the cache.    
            baseOverlay.DrawingExceptionMode = DrawingExceptionMode.DrawException;

            // Add the newly created overlay to mapView.
            Map.Overlays.Add(baseOverlay);

            // Refresh the Map
            await Map.RefreshAsync();
        }
    }

    class MyMapView : MapView
    {
        [NonSerialized]
        private Canvas allEventCanvas;
        protected override Task DrawAsyncCore(RectangleShape targetExtent, OverlayRefreshType overlayRefreshType, CancellationToken cancellationToken)
        {
            if (allEventCanvas.ActualHeight < ActualHeight * 2)
            {
                allEventCanvas.Height = ActualHeight * 2;
                allEventCanvas.Width = ActualWidth * 2;
                allEventCanvas.Margin = new Thickness(-ActualWidth / 2, -ActualHeight / 2, 0, 0);
            }
            return base.DrawAsyncCore(targetExtent, overlayRefreshType, cancellationToken);
        }

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            allEventCanvas = (Canvas)GetTemplateChild("AllEventCanvas");
        }
    }
}